#ifndef CGATE_H
#define CGATE_H

#include "pre.h"
#include <malloc.h>
#include <stdio.h>

extern MosList *MosHead;
extern NodeList *NodeHead;

class CGate {
     
     friend class Group;
     friend class Branch;

     public:
		char *gatename;
		Branch *n_branch;
		Branch *p_branch;
		bool cmos_gate;
		PinList *inlist;
		bool pn_input_match;
		bool unique;
		CGate *next;

	CGate::CGate(char *name, Branch *nbranch, Branch *pbranch, bool cmos_gate_);
	~CGate();
};

#endif
