
void
Group::n_branch_recognition()
{
    const char *model_name = "N_Model_";
    char model_add = 'a';
    for(Branch *curr_n=n_branch_list; curr_n!=NULL; curr_n=curr_n->next)
    {
		if(curr_n->num_of_mos == 1)
		{
			MosList *mos;
			mos=curr_n->mos_list;
			curr_n->name_list = curr_n->insert_name(curr_n->name_list, mos->g, 'a');
			mos->g=generate_mark("a");	
			curr_n->headername = NLAlloc(char, 4);
			strcpy(curr_n->headername, "INV");
		}
		else if(curr_n->num_of_mos>1 && curr_n->num_of_mos<=6)
		{
			char input_name;
			input_name='a';
			MosList *list=curr_n->mos_list;
			while(counter(curr_n)!=1)
			{
			    input_name = parallel_recognition(curr_n,input_name); 

			    input_name = series_recognition(curr_n, input_name);
			}

			list->g = generate_mark(list->g);

			MosList *currmos=curr_n->mos_list;
                    if(!strcmp(currmos->g, "~(a | b)"))
                    {
                        curr_n->headername = NLAlloc(char, 6);
                        strcpy(curr_n->headername, "NOR2");
                    }
                    else if(!strcmp(currmos->g, "~(a & b)"))
                    {
                        curr_n->headername = NLAlloc(char, 6);
                        strcpy(curr_n->headername, "NAND2");
                    }
                    else if(!strcmp(currmos->g, "~(a | b | c)") || !strcmp(currmos->g, "~((a | b) | c)"))
                    {
                        curr_n->headername = NLAlloc(char, 6);
                        strcpy(curr_n->headername, "NOR3");
                    }
                    else if(!strcmp(currmos->g, "~(a & b & c)") || !strcmp(currmos->g, "~((a & b) & c)"))
                    {
                        curr_n->headername = NLAlloc(char, 6);
                        strcpy(curr_n->headername, "NAND3");
                    }
                    else if(!strcmp(currmos->g, "~((a | b) & c)"))
                    {
                        curr_n->headername = NLAlloc(char, 6);
                        strcpy(curr_n->headername, "OAI12");
                    }
                    else if(!strcmp(currmos->g, "~((a & b) | c)"))
                    {
                        curr_n->headername = NLAlloc(char, 6);
                        strcpy(curr_n->headername, "AOI12");
                    }
                    else if(!strcmp(currmos->g, "~((a | b) | (c | d))") || !strcmp(currmos->g, "~((a | b | c) | d)") || !strcmp(currmos->g, "~(a | b | c | d)"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "NOR4");
                    }
                    else if(!strcmp(currmos->g, "~((a & b) & (c & d))") || !strcmp(currmos->g, "~((a & b & c) & d)") || !strcmp(currmos->g, "~(a & b & c & d)"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "NAND4");
                    }
                    else if(!strcmp(currmos->g, "~((a & b) | (c & d))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOI22");
                    }
                    else if(!strcmp(currmos->g, "~((a | b) & (c | d))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAI22");
                    }
//                    else if(!strcmp(currmos->g, "~((a & b & c) | d)"))
                    else if(!strcmp(currmos->g, "~((a & b & c) | d)") || !strcmp(currmos->g, "~(((a & b) & c) |d)"))   // Revised by Yang Lei, Oct 26.
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOI13");
                    }
                    else if(!strcmp(currmos->g, "~((a | b | c) & d)") || !strcmp(currmos->g, "(((a | b) | c) & d)"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAI13");
                    }
                    else if(!strcmp(currmos->g, "~(((a | b) & c) | d)"))
                    {
                            curr_n->headername = NLAlloc(char, 8);
                            strcpy(curr_n->headername, "OAOI112");
		    		}
//                    else if(!strcmp(currmos->g, "~((a & b) | c | d)"))
                    else if(!strcmp(currmos->g, "~((a | b) | (c & d))"))
                    {
                            curr_n->headername = NLAlloc(char, 8);
                            strcpy(curr_n->headername, "AOOI112");
                    }
//                    else if(!strcmp(currmos->g, "~((a | b) & c & d)"))
                    else if(!strcmp(currmos->g, "~((a | b) & c & d)") || !strcmp(currmos->g, "~((a | b) & (c & d))") || !strcmp(currmos->g, "~(((a | b) & c) & d)"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAAI112");
                    }
                    else if(!strcmp(currmos->g, "~(((a & b) | c) & d)"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOAI112");
                    }

// The following is added by Yang Lei, Oct, 26, 2002

                    else if(!strcmp(currmos->g, "~((a & b) | (c & d & e))") || !strcmp(currmos->g, "~((a & b) | ((c & d) & e))") || !strcmp(currmos->g,"~((a & b & c) | (d & e))") || !strcmp(currmos->g, "~(((a & b) & e) | (c & d))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOI23");
                    }
                    else if(!strcmp(currmos->g, "~((a | b) | (c & d & e))") || !strcmp(currmos->g, "~((a | b) | ((c & d) & e))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOI311");
                    }
                    else if(!strcmp(currmos->g, "~((a & b) | (c & d) | e)") || !strcmp(currmos->g, "~((a & b) | e | (c & d))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOI221");
                    }
                    else if(!strcmp(currmos->g, "~((a | b | c) & (d | e))") || !strcmp(currmos->g, "~((a | b) & (c | d | e))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAI23");
                    }
                    else if(!strcmp(currmos->g, "~((a | b | c) & d & e)") || !strcmp(currmos->g, "~(((a | b | c) & d) & e)") || !strcmp(currmos->g,"~((a | b | c) & (d & e))") || !strcmp(currmos->g, "~((d & e) & (a | b | c))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAI311");
                    }
                    else if(!strcmp(currmos->g, "~((a | b) & (c | d) & e)") || !strcmp(currmos->g, "~((a | b) & e & (c | d))") || !strcmp(currmos->g,"~(((a | b) & (c | d)) & e)") || !strcmp(currmos->g, "~(((a | b) & e) & (c | d))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAI221");
                    }

                    else if(!strcmp(currmos->g, "~(((a | b) & c) | (d & e))") || !strcmp(currmos->g, "~(((a | b) & e) | (c & d))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAOI212");
                    }
                    else if(!strcmp(currmos->g, "~(((a | b) & e) | (c | d))") || !strcmp(currmos->g, "~((a | b) | ((c | d) & e))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAOI2111");
                    }
                    else if(!strcmp(currmos->g, "~((a | b) & ((c & d) | e))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOAI212");
                    }
                    else if(!strcmp(currmos->g, "~(((a & b) | e) & (c & d))") || !strcmp(currmos->g, "~((a & b) & ((c & d) | e))") || !strcmp(currmos->g,"~(((a & b) | c) & d & e)") || !strcmp(currmos->g, "~((((a & b) | c) & d) & e)"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOAI2111");
                    }

                    else if(!strcmp(currmos->g, "~((a & b & c) | (d & e & f))") || !strcmp(currmos->g, "~(((a & b) & f) | ((c & d & e))") || !strcmp(currmos->g,"~((a & b & c) | ((d & e) & f))") || !strcmp(currmos->g, "~(((a & b) & e) | (c & d) & f))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOI33");
                    }
                    else if(!strcmp(currmos->g, "~((a & b &c) | (d & e) | f)") || !strcmp(currmos->g, "~(((a & b) & e) | (c & d) | f)") || !strcmp(currmos->g,"~((a & b) | (c & d & e) | f)") || !strcmp(currmos->g, "~((a & b) | ((c & d) & e) | f)") || !strcmp(currmos->g, "~((a & b & c) | f | (d & e))") || !strcmp(currmos->g, "~(((a & b) & e) | f | (c & d))") || !strcmp(currmos->g, "~((a & b) | f | (c & d & e))") || !strcmp(currmos->g, "~((a & b) | f | ((c & d) & e))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOI321");
                    }
                    else if(!strcmp(currmos->g, "~((a & b) | (c & d) | (e & f))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOI222");
                    }
                    else if(!strcmp(currmos->g, "~((a | b) & (c | d) & (e | f))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAI222");
                    }
                    else if(!strcmp(currmos->g, "~((a | b | c) & (d & e & f))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAI33");
                    }
                    else if(!strcmp(currmos->g, "~((a | b | c) & (d | e) & f)") || !strcmp(currmos->g, "~((a | b) & (c | d | e) & f)") || !strcmp(currmos->g,"~((a | b | c) & f (d | e))") || !strcmp(currmos->g, "~((a | b) & f & (c | d | e))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAI321");
                    }
		    		else if(!strcmp(currmos->g, "~a"))
		    		{
						;
		    		}
		    		else
		    		{           
	                	char input_name;
                        input_name='a';
                        MosList *list=curr_n->mos_list;
                        while(counter(curr_n)!=1)
                        {
                            input_name = parallel_recognition(curr_n,input_name);

                            input_name = series_recognition(curr_n, input_name);
                        }
                        list->g = generate_mark(list->g);
						curr_n->greatthan4 = 1;
                        curr_n->headername = NLAlloc(char, strlen(model_name)+2);
                        strcpy(curr_n->headername, model_name);
                        int k = strlen(curr_n->headername);
                        curr_n->headername[k]=model_add;
                        curr_n->headername[k+1]='\0';
                        model_add+=1;
						printf("This n_branch contains more than 7 mosfets, can't handle\n");
						printf("Branch name = %s, Logic function is: \n", curr_n->headername, list->g);
		     		}
		}
    }
}
				
void
Group::p_branch_recognition()
{
    const char *model_name = "P_Model_";
    char model_add = 'a';
    for(Branch *curr_n=p_branch_list; curr_n!=NULL; curr_n=curr_n->next)
    {
		if(curr_n->num_of_mos == 1)
		{
			MosList *mos;
			mos=curr_n->mos_list;
			curr_n->name_list = curr_n->insert_name(curr_n->name_list, mos->g, 'a');
			mos->g=generate_mark("a");	
			curr_n->headername = NLAlloc(char, 4);
			strcpy(curr_n->headername, "INV");
		}
		else if(curr_n->num_of_mos>1 && curr_n->num_of_mos<=6)
		{
			char input_name;
			input_name='a';
			MosList *list=curr_n->mos_list;
			while(counter(curr_n)!=1)
			{
			    input_name = parallel_recognition(curr_n,input_name); 

			    input_name = series_recognition(curr_n, input_name);
			}

			list->g = generate_mark(list->g);

			MosList *currmos=curr_n->mos_list;
                    if(!strcmp(currmos->g, "~(a | b)"))
                    {
                        curr_n->headername = NLAlloc(char, 6);
                        strcpy(curr_n->headername, "NOR2");
                    }
                    else if(!strcmp(currmos->g, "~(a & b)"))
                    {
                        curr_n->headername = NLAlloc(char, 6);
                        strcpy(curr_n->headername, "NAND2");
                    }
                    else if(!strcmp(currmos->g, "~(a | b | c)") || !strcmp(currmos->g, "~((a | b) | c)"))
                    {
                        curr_n->headername = NLAlloc(char, 6);
                        strcpy(curr_n->headername, "NOR3");
                    }
                    else if(!strcmp(currmos->g, "~(a & b & c)") || !strcmp(currmos->g, "~((a & b) & c)"))
                    {
                        curr_n->headername = NLAlloc(char, 6);
                        strcpy(curr_n->headername, "NAND3");
                    }
                    else if(!strcmp(currmos->g, "~((a | b) & c)"))
                    {
                        curr_n->headername = NLAlloc(char, 6);
                        strcpy(curr_n->headername, "OAI12");
                    }
                    else if(!strcmp(currmos->g, "~((a & b) | c)"))
                    {
                        curr_n->headername = NLAlloc(char, 6);
                        strcpy(curr_n->headername, "AOI12");
                    }
                    else if(!strcmp(currmos->g, "~((a | b) | (c | d))") || !strcmp(currmos->g, "~((a | b | c) | d)") || !strcmp(currmos->g, "~(a | b | c | d)"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "NOR4");
                    }
                    else if(!strcmp(currmos->g, "~((a & b) & (c & d))") || !strcmp(currmos->g, "~((a & b & c) & d)") || !strcmp(currmos->g, "~(a & b & c & d)"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "NAND4");
                    }
                    else if(!strcmp(currmos->g, "~((a & b) | (c & d))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOI22");
                    }
                    else if(!strcmp(currmos->g, "~((a | b) & (c | d))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAI22");
                    }
//                    else if(!strcmp(currmos->g, "~((a & b & c) | d)"))
                    else if(!strcmp(currmos->g, "~((a & b & c) | d)") || !strcmp(currmos->g, "~(((a & b) & c) |d)"))   // Revised by Yang Lei, Oct 26.
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOI13");
                    }
                    else if(!strcmp(currmos->g, "~((a | b | c) & d)") || !strcmp(currmos->g, "(((a | b) | c) & d)"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAI13");
                    }
                    else if(!strcmp(currmos->g, "~(((a | b) & c) | d)"))
                    {
                            curr_n->headername = NLAlloc(char, 8);
                            strcpy(curr_n->headername, "OAOI112");
		    		}
//                    else if(!strcmp(currmos->g, "~((a & b) | c | d)"))
                    else if(!strcmp(currmos->g, "~((a | b) | (c & d))"))
                    {
                            curr_n->headername = NLAlloc(char, 8);
                            strcpy(curr_n->headername, "AOOI112");
                    }
//                    else if(!strcmp(currmos->g, "~((a | b) & c & d)"))
                    else if(!strcmp(currmos->g, "~((a | b) & c & d)") || !strcmp(currmos->g, "~((a | b) & (c & d))") || !strcmp(currmos->g, "~(((a | b) & c) & d)"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAAI112");
                    }
                    else if(!strcmp(currmos->g, "~(((a & b) | c) & d)"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOAI112");
                    }

// The following is added by Yang Lei, Oct, 26, 2002

                    else if(!strcmp(currmos->g, "~((a & b) | (c & d & e))") || !strcmp(currmos->g, "~((a & b) | ((c & d) & e))") || !strcmp(currmos->g,"~((a & b & c) | (d & e))") || !strcmp(currmos->g, "~(((a & b) & e) | (c & d))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOI23");
                    }
                    else if(!strcmp(currmos->g, "~((a | b) | (c & d & e))") || !strcmp(currmos->g, "~((a | b) | ((c & d) & e))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOI311");
                    }
                    else if(!strcmp(currmos->g, "~((a & b) | (c & d) | e)") || !strcmp(currmos->g, "~((a & b) | e | (c & d))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOI221");
                    }
                    else if(!strcmp(currmos->g, "~((a | b | c) & (d | e))") || !strcmp(currmos->g, "~((a | b) & (c | d | e))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAI23");
                    }
                    else if(!strcmp(currmos->g, "~((a | b | c) & d & e)") || !strcmp(currmos->g, "~(((a | b | c) & d) & e)") || !strcmp(currmos->g,"~((a | b | c) & (d & e))") || !strcmp(currmos->g, "~((d & e) & (a | b | c))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAI311");
                    }
                    else if(!strcmp(currmos->g, "~((a | b) & (c | d) & e)") || !strcmp(currmos->g, "~((a | b) & e & (c | d))") || !strcmp(currmos->g,"~(((a | b) & (c | d)) & e)") || !strcmp(currmos->g, "~(((a | b) & e) & (c | d))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAI221");
                    }

                    else if(!strcmp(currmos->g, "~(((a | b) & c) | (d & e))") || !strcmp(currmos->g, "~(((a | b) & e) | (c & d))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAOI212");
                    }
                    else if(!strcmp(currmos->g, "~(((a | b) & e) | (c | d))") || !strcmp(currmos->g, "~((a | b) | ((c | d) & e))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAOI2111");
                    }
                    else if(!strcmp(currmos->g, "~((a | b) & ((c & d) | e))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOAI212");
                    }
                    else if(!strcmp(currmos->g, "~(((a & b) | e) & (c & d))") || !strcmp(currmos->g, "~((a & b) & ((c & d) | e))") || !strcmp(currmos->g,"~(((a & b) | c) & d & e)") || !strcmp(currmos->g, "~((((a & b) | c) & d) & e)"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOAI2111");
                    }

                    else if(!strcmp(currmos->g, "~((a & b & c) | (d & e & f))") || !strcmp(currmos->g, "~(((a & b) & f) | ((c & d & e))") || !strcmp(currmos->g,"~((a & b & c) | ((d & e) & f))") || !strcmp(currmos->g, "~(((a & b) & e) | (c & d) & f))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOI33");
                    }
                    else if(!strcmp(currmos->g, "~((a & b &c) | (d & e) | f)") || !strcmp(currmos->g, "~(((a & b) & e) | (c & d) | f)") || !strcmp(currmos->g,"~((a & b) | (c & d & e) | f)") || !strcmp(currmos->g, "~((a & b) | ((c & d) & e) | f)") || !strcmp(currmos->g, "~((a & b & c) | f | (d & e))") || !strcmp(currmos->g, "~(((a & b) & e) | f | (c & d))") || !strcmp(currmos->g, "~((a & b) | f | (c & d & e))") || !strcmp(currmos->g, "~((a & b) | f | ((c & d) & e))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOI321");
                    }
                    else if(!strcmp(currmos->g, "~((a & b) | (c & d) | (e & f))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "AOI222");
                    }
                    else if(!strcmp(currmos->g, "~((a | b) & (c | d) & (e | f))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAI222");
                    }
                    else if(!strcmp(currmos->g, "~((a | b | c) & (d & e & f))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAI33");
                    }
                    else if(!strcmp(currmos->g, "~((a | b | c) & (d | e) & f)") || !strcmp(currmos->g, "~((a | b) & (c | d | e) & f)") || !strcmp(currmos->g,"~((a | b | c) & f (d | e))") || !strcmp(currmos->g, "~((a | b) & f & (c | d | e))"))
                    {
                        curr_n->headername = NLAlloc(char, 8);
                        strcpy(curr_n->headername, "OAI321");
                    }
		    		else if(!strcmp(currmos->g, "~a"))
		    		{
						;
		    		}
		    		else
		    		{           
	                	char input_name;
                        input_name='a';
                        MosList *list=curr_n->mos_list;
                        while(counter(curr_n)!=1)
                        {
                            input_name = parallel_recognition(curr_n,input_name);

                            input_name = series_recognition(curr_n, input_name);
                        }
                        list->g = generate_mark(list->g);
						curr_n->greatthan4 = 1;
                        curr_n->headername = NLAlloc(char, strlen(model_name)+2);
                        strcpy(curr_n->headername, model_name);
                        int k = strlen(curr_n->headername);
                        curr_n->headername[k]=model_add;
                        curr_n->headername[k+1]='\0';
                        model_add+=1;
						printf("This p_branch contains more than 7 mosfets, can't handle\n");
						printf("Branch name = %s, Logic function is: \n", curr_n->headername, list->g);
		     		}
		}
    }
}

CGate *
Group::insert_cgate(CGate *head, CGate *newgate)
{
    CGate *current;
    if(head==NULL)
    {
	head=NLAlloc(CGate,1);
	head->n_branch = newgate->n_branch;
	head->p_branch = newgate->p_branch;
	head->cmos_gate = newgate->cmos_gate;
	head->next = NULL;
    }
    else
    {
	current=NLAlloc(CGate,1);
	current->n_branch=newgate->n_branch;
	current->p_branch=newgate->p_branch;
	current->cmos_gate = newgate->cmos_gate;
	current->next = head->next;
	head->next = current;
    }
    return head;
}

void
Group::gate_recognition()
{
	for(Branch *curr_n=n_branch_list; curr_n!=NULL; curr_n=curr_n->next)
	{
		for(Branch *curr_p=p_branch_list; curr_p!=NULL; curr_p=curr_p->next)
		{
			if(!strcmp(curr_n->pn_node, curr_p->pn_node))
			{

/*
					printf("........ A new gate, pn_node = %s: \n", curr_n->pn_node);
					printf("N_number=%d, P_number=%d\n", curr_n->num_of_mos, curr_p->num_of_mos);
					printf("N_fun=%s, P_fun=%s\n", (curr_n->mos_list)->g, (curr_p->mos_list)->g);
					printf("N_fun=%s, P_fun=%s\n", curr_n->headername, curr_p->headername);
*/

				if(curr_n->num_of_mos != curr_p->num_of_mos)
				{
					CGate *new_gate = new CGate(curr_n, curr_p, false); 
					special_gate_list = insert_cgate(special_gate_list, new_gate);
				}
				else
				{
					if(
						  ( !strcmp(curr_n->headername,"INV") && !strcmp(curr_p->headername, "INV") )
					  ||  ( !strcmp(curr_n->headername,"NAND2") && !strcmp(curr_p->headername, "NOR2") )
					  ||  ( !strcmp(curr_n->headername,"NOR2") && !strcmp(curr_p->headername, "NAND2") )
					  ||  ( !strcmp(curr_n->headername,"NAND3") && !strcmp(curr_p->headername, "NOR3") )
					  ||  ( !strcmp(curr_n->headername,"NOR3") && !strcmp(curr_p->headername, "NAND3") )
					  ||  ( !strcmp(curr_n->headername,"OAI12") && !strcmp(curr_p->headername, "AOI12") )
					  ||  ( !strcmp(curr_n->headername,"AOI12") && !strcmp(curr_p->headername, "OAI12") )
					  ||  ( !strcmp(curr_n->headername,"NOR4") && !strcmp(curr_p->headername, "NAND4") )
					  ||  ( !strcmp(curr_n->headername,"NAND4") && !strcmp(curr_p->headername, "NOR4") )
					  ||  ( !strcmp(curr_n->headername,"AOI22") && !strcmp(curr_p->headername, "OAI22") )
					  ||  ( !strcmp(curr_n->headername,"OAI22") && !strcmp(curr_p->headername, "AOI22") )
					  ||  ( !strcmp(curr_n->headername,"AOI13") && !strcmp(curr_p->headername, "OAI13") )
					  ||  ( !strcmp(curr_n->headername,"OAI13") && !strcmp(curr_p->headername, "AOI13") )
					  ||  ( !strcmp(curr_n->headername,"OAOI112") && !strcmp(curr_p->headername, "AOAI112") )
					  ||  ( !strcmp(curr_n->headername,"AOOI112") && !strcmp(curr_p->headername, "OAAI112") )
					  ||  ( !strcmp(curr_n->headername,"OAAI112") && !strcmp(curr_p->headername, "AOOI112") )
					  ||  ( !strcmp(curr_n->headername,"AOAI112") && !strcmp(curr_p->headername, "OAOI112") )
					  ||  ( !strcmp(curr_n->headername,"AOI23") && !strcmp(curr_p->headername, "OAI23") )
					  ||  ( !strcmp(curr_n->headername,"AOI311") && !strcmp(curr_p->headername, "OAI311") )
					  ||  ( !strcmp(curr_n->headername,"AOI221") && !strcmp(curr_p->headername, "OAI221") )
					  ||  ( !strcmp(curr_n->headername,"OAI23") && !strcmp(curr_p->headername, "AOI23") )
					  ||  ( !strcmp(curr_n->headername,"OAI311") && !strcmp(curr_p->headername, "AOI311") )
					  ||  ( !strcmp(curr_n->headername,"OAI221") && !strcmp(curr_p->headername, "AOI221") )

					  ||  ( !strcmp(curr_n->headername,"OAOI212") && !strcmp(curr_p->headername, "AOAI212") )
					  ||  ( !strcmp(curr_n->headername,"OAOI2111") && !strcmp(curr_p->headername, "AOAI2111") )
					  ||  ( !strcmp(curr_n->headername,"AOAI212") && !strcmp(curr_p->headername, "OAOI212") )
					  ||  ( !strcmp(curr_n->headername,"AOAI2111") && !strcmp(curr_p->headername, "AOAI2111") )

					  ||  ( !strcmp(curr_n->headername,"AOI33") && !strcmp(curr_p->headername, "OAI33") )
					  ||  ( !strcmp(curr_n->headername,"AOI321") && !strcmp(curr_p->headername, "OAI321") )
					  ||  ( !strcmp(curr_n->headername,"AOI222") && !strcmp(curr_p->headername, "OAI222") )
					  ||  ( !strcmp(curr_n->headername,"OAI222") && !strcmp(curr_p->headername, "AOI222") )
					  ||  ( !strcmp(curr_n->headername,"OAI33") && !strcmp(curr_p->headername, "AOI33") )
					  ||  ( !strcmp(curr_n->headername,"OAI321") && !strcmp(curr_p->headername, "AOI321") ) )
					{
						CGate *new_2_gate = new CGate(curr_n, curr_p, true);
						cmos_gate_list = insert_cgate(cmos_gate_list, new_2_gate);
					}
					else
					{
						CGate *new_3_gate = new CGate(curr_n, curr_p, true);
						special_gate_list = insert_cgate(special_gate_list, new_3_gate);
					}
				}
				break;
			}
		}
	}
}

int
Group::query_inoutput(char *name)
{
    int flag = 0;
    for(InoutList *curr=InputHead; curr!=NULL; curr=curr->next)
    {
	if(!strcmp(curr->pinname, name))
	{
	    flag=1;
	    return 1;
	}
    }
    for(InoutList *curr2=OutputHead; curr2!=NULL; curr2=curr2->next)
    {
	if(!strcmp(curr2->pinname, name))
	{
	    flag=1;
	    return 1;
	}
    }

    if(!flag)
	return 0;
}

WireList *
Group::insert_wire(WireList *head, char *name)
{
    WireList *current;
    if(head==NULL)
    {
	head=NLAlloc(WireList,1);
	head->wirename=NLAlloc(char, strlen(name));
	strcpy(head->wirename,name);
	head->next = NULL;
    }
    else
    {
	current=NLAlloc(WireList,1);
	current->wirename=NLAlloc(char, strlen(name));
	strcpy(current->wirename,name);
	current->next = head->next;
	head->next = current;
    }
    return head;
}

int
Group::query_wire(char *wire)
{
    int flag=0;
    for(WireList *curr_w=WireHead; curr_w!=NULL; curr_w=curr_w->next)
    {
	if(!strcmp(curr_w->wirename, wire))
	{
	    flag=1;
	    break;
	}
    }

    return flag;
}

void
Group::generate_wirelist()
{
    for(Branch *curr_b=n_branch_list; curr_b!=NULL; curr_b=curr_b->next)
    {
        for(NameList *curr_name=curr_b->name_list; curr_name!=NULL; curr_name=curr_name->next)
        {
            if(!query_inoutput(curr_name->gatename))
                WireHead=insert_wire(WireHead,curr_name->gatename);
        }
    }
    for(TransList *curr_t=TransHead; curr_t!=NULL; curr_t=curr_t->next)
    {
        if(!query_wire(curr_t->input) && !query_inoutput(curr_t->input))
            WireHead=insert_wire(WireHead,curr_t->input);
        if(!query_wire(curr_t->output) && !query_inoutput(curr_t->output))
            WireHead=insert_wire(WireHead,curr_t->output);
    }
/*
    for(DffList *curr_d=DffHead; curr_d!=NULL; curr_d=curr_d->next)
    {
        if(!query_wire(curr_d->d) && !query_inoutput(curr_d->d))
            WireHead=insert_wire(WireHead, curr_d->d);
        if(!query_wire(curr_d->q) && !query_inoutput(curr_d->q))
            WireHead=insert_wire(WireHead,curr_d->q);
        if(!query_wire(curr_d->clk) && !query_inoutput(curr_d->clk))
            WireHead=insert_wire(WireHead,curr_d->clk);
        if(!query_wire(curr_d->rst) && !query_inoutput(curr_d->rst))
            WireHead=insert_wire(WireHead,curr_d->rst);
    }
*/
}

void
Group::delete_wire()
{
    for(WireList *curr_w=WireHead; curr_w!=NULL; curr_w=curr_w->next)
    {
        WireList *curr, *prev;
        prev=curr_w;
        curr=prev->next;
        while(curr!=NULL)
        {
	    if(!strcmp(curr_w->wirename, curr->wirename))
	    {
		prev->next = curr->next;
		curr = prev->next;
	    }
	    else
	    {
		prev=curr;
		curr=curr->next;
	    }
	}
    }
}
