#include <sys/timeb.h>

static struct timeb timebegin;

void startTimer() {ftime(&timebegin);}

void timediff(struct timeb* now, struct timeb* begin, int* sec, int* msec) {
  *msec = now->millitm - begin->millitm;
  *sec = now->time - begin->time;
  if (*msec < 0) {
    *msec += 1000;
    (*sec)--;
  }
  return;
}

double runInSeconds() {
  struct timeb timenow;
  int sec, msec;

  ftime(&timenow);
  timediff(&timenow, &timebegin, &sec, &msec);
  return (sec + (double) msec / 1000.0);
}

