#include "pre.h"
#include "branch.h"
#include "cgate.h"
#include <malloc.h>
#include <stdio.h>
#include <cstring>
using namespace std;

#define NLAlloc(type,num) (type *)calloc(num,sizeof(type))

extern MosList *MosHead;
extern NodeList *NodeHead;

CGate::CGate(char *name, Branch *nbranch, Branch *pbranch, bool cmos_gate_)
{
	gatename = NLAlloc(char, strlen(name));
	strcpy(gatename, name);
	n_branch = nbranch;
	p_branch = pbranch;
	inlist = NULL;
	pn_input_match = true;
	unique = true;
	cmos_gate = cmos_gate_;
}

CGate::~CGate()
{
	if(n_branch) delete n_branch;
	if(p_branch) delete p_branch;
}

